/* GStreamerTagger.c generated by valac 0.44.0, the Vala compiler
 * generated from GStreamerTagger.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>,
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <gst/pbutils/pbutils.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gst/gst.h>
#include "io.elementary.music-core.h"
#include <float.h>
#include <math.h>
#include <time.h>

#define NOISE_TYPE_GSTREAMER_TAGGER (noise_gstreamer_tagger_get_type ())
#define NOISE_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger))
#define NOISE_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))
#define NOISE_IS_GSTREAMER_TAGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_IS_GSTREAMER_TAGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_GSTREAMER_TAGGER))
#define NOISE_GSTREAMER_TAGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTaggerClass))

typedef struct _NoiseGStreamerTagger NoiseGStreamerTagger;
typedef struct _NoiseGStreamerTaggerClass NoiseGStreamerTaggerClass;
typedef struct _NoiseGStreamerTaggerPrivate NoiseGStreamerTaggerPrivate;
enum  {
	NOISE_GSTREAMER_TAGGER_0_PROPERTY,
	NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES
};
static GParamSpec* noise_gstreamer_tagger_properties[NOISE_GSTREAMER_TAGGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _gst_date_time_unref0(var) ((var == NULL) ? NULL : (var = (gst_date_time_unref (var), NULL)))
enum  {
	NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL,
	NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL,
	NOISE_GSTREAMER_TAGGER_NUM_SIGNALS
};
static guint noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_NUM_SIGNALS] = {0};

struct _NoiseGStreamerTagger {
	GObject parent_instance;
	NoiseGStreamerTaggerPrivate * priv;
};

struct _NoiseGStreamerTaggerClass {
	GObjectClass parent_class;
};

struct _NoiseGStreamerTaggerPrivate {
	GstDiscoverer* d;
	GeeLinkedList* uri_queue;
	GRecMutex __lock_uri_queue;
	GCancellable* cancellable;
};

static gint NoiseGStreamerTagger_private_offset;
static gpointer noise_gstreamer_tagger_parent_class = NULL;

GType noise_gstreamer_tagger_get_type (void) G_GNUC_CONST;
#define NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT 5
NoiseGStreamerTagger* noise_gstreamer_tagger_new (GCancellable* cancellable);
NoiseGStreamerTagger* noise_gstreamer_tagger_construct (GType object_type,
                                                        GCancellable* cancellable);
static void noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                          GstDiscovererInfo* info,
                                          GError* err);
static void _noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                     GstDiscovererInfo* info,
                                                                     GError* err,
                                                                     gpointer self);
static void noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self);
static void _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                        gpointer self);
static void noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self);
void noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                     GeeCollection* uris);
static void* __lambda12_ (NoiseGStreamerTagger* self);
static gpointer ___lambda12__gthread_func (gpointer self);
static GDate* _g_date_dup (GDate* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void noise_gstreamer_tagger_finalize (GObject * obj);

static inline gpointer
noise_gstreamer_tagger_get_instance_private (NoiseGStreamerTagger* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseGStreamerTagger_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	return self ? g_object_ref (self) : NULL;
#line 136 "GStreamerTagger.c"
}

static void
_noise_gstreamer_tagger_import_media_gst_discoverer_discovered (GstDiscoverer* _sender,
                                                                GstDiscovererInfo* info,
                                                                GError* err,
                                                                gpointer self)
{
#line 48 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_media ((NoiseGStreamerTagger*) self, info, err);
#line 147 "GStreamerTagger.c"
}

static void
_noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished (GstDiscoverer* _sender,
                                                                   gpointer self)
{
#line 49 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_file_set_finished ((NoiseGStreamerTagger*) self);
#line 156 "GStreamerTagger.c"
}

NoiseGStreamerTagger*
noise_gstreamer_tagger_construct (GType object_type,
                                  GCancellable* cancellable)
{
	NoiseGStreamerTagger * self = NULL;
	GCancellable* _tmp0_;
	GCancellable* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	self = (NoiseGStreamerTagger*) g_object_new (object_type, NULL);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = _g_object_ref0 (cancellable);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 42 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp0_;
#line 43 "../src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = self->priv->cancellable;
#line 43 "../src/GStreamer/GStreamerTagger.vala"
	if (_tmp1_ == NULL) {
#line 179 "GStreamerTagger.c"
		GCancellable* _tmp2_;
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = g_cancellable_new ();
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->cancellable);
#line 44 "../src/GStreamer/GStreamerTagger.vala"
		self->priv->cancellable = _tmp2_;
#line 187 "GStreamerTagger.c"
	}
	{
		GstDiscoverer* _tmp3_ = NULL;
		GstDiscoverer* _tmp4_;
		GstDiscoverer* _tmp5_;
		GstDiscoverer* _tmp6_;
		GstDiscoverer* _tmp7_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = gst_discoverer_new ((GstClockTime) (NOISE_GSTREAMER_TAGGER_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = _tmp4_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 201 "GStreamerTagger.c"
			goto __catch27_g_error;
		}
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp5_ = _tmp3_;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = NULL;
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (self->priv->d);
#line 47 "../src/GStreamer/GStreamerTagger.vala"
		self->priv->d = _tmp5_;
#line 48 "../src/GStreamer/GStreamerTagger.vala"
		_tmp6_ = self->priv->d;
#line 48 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp6_, "discovered", (GCallback) _noise_gstreamer_tagger_import_media_gst_discoverer_discovered, self, 0);
#line 49 "../src/GStreamer/GStreamerTagger.vala"
		_tmp7_ = self->priv->d;
#line 49 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_connect_object (_tmp7_, "finished", (GCallback) _noise_gstreamer_tagger_file_set_finished_gst_discoverer_finished, self, 0);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_g_object_unref0 (_tmp3_);
#line 222 "GStreamerTagger.c"
	}
	goto __finally27;
	__catch27_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		err = _inner_error0_;
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_inner_error0_ = NULL;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		_tmp8_ = err;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		_tmp9_ = _tmp8_->message;
#line 51 "../src/GStreamer/GStreamerTagger.vala"
		g_critical ("GStreamerTagger.vala:51: Could not create Gst discoverer object: %s", _tmp9_);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		_g_error_free0 (err);
#line 242 "GStreamerTagger.c"
	}
	__finally27:
#line 46 "../src/GStreamer/GStreamerTagger.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		g_clear_error (&_inner_error0_);
#line 46 "../src/GStreamer/GStreamerTagger.vala"
		return NULL;
#line 253 "GStreamerTagger.c"
	}
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	return self;
#line 257 "GStreamerTagger.c"
}

NoiseGStreamerTagger*
noise_gstreamer_tagger_new (GCancellable* cancellable)
{
#line 41 "../src/GStreamer/GStreamerTagger.vala"
	return noise_gstreamer_tagger_construct (NOISE_TYPE_GSTREAMER_TAGGER, cancellable);
#line 265 "GStreamerTagger.c"
}

static void
noise_gstreamer_tagger_file_set_finished (NoiseGStreamerTagger* self)
{
	GCancellable* _tmp0_;
#line 55 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 56 "../src/GStreamer/GStreamerTagger.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 278 "GStreamerTagger.c"
		GstDiscoverer* _tmp1_;
#line 57 "../src/GStreamer/GStreamerTagger.vala"
		g_debug ("GStreamerTagger.vala:57: import cancelled");
#line 58 "../src/GStreamer/GStreamerTagger.vala"
		_tmp1_ = self->priv->d;
#line 58 "../src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp1_);
#line 59 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 288 "GStreamerTagger.c"
	} else {
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp2_ = self->priv->uri_queue;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		_tmp4_ = _tmp3_;
#line 60 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp4_ == 0) {
#line 301 "GStreamerTagger.c"
			GstDiscoverer* _tmp5_;
#line 61 "../src/GStreamer/GStreamerTagger.vala"
			g_debug ("GStreamerTagger.vala:61: queue finished");
#line 62 "../src/GStreamer/GStreamerTagger.vala"
			_tmp5_ = self->priv->d;
#line 62 "../src/GStreamer/GStreamerTagger.vala"
			gst_discoverer_stop (_tmp5_);
#line 63 "../src/GStreamer/GStreamerTagger.vala"
			g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 311 "GStreamerTagger.c"
		} else {
#line 65 "../src/GStreamer/GStreamerTagger.vala"
			noise_gstreamer_tagger_import_next_file_set (self);
#line 315 "GStreamerTagger.c"
		}
	}
}

static void
noise_gstreamer_tagger_import_next_file_set (NoiseGStreamerTagger* self)
{
	GError* _inner_error0_ = NULL;
#line 69 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 326 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 333 "GStreamerTagger.c"
		{
			{
				gchar* uri = NULL;
				GeeLinkedList* _tmp1_;
				gpointer _tmp2_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_tmp1_ = self->priv->uri_queue;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_tmp2_ = gee_deque_poll_head ((GeeDeque*) _tmp1_);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				uri = (gchar*) _tmp2_;
#line 345 "GStreamerTagger.c"
				{
					gboolean _tmp3_ = FALSE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
					_tmp3_ = TRUE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
					while (TRUE) {
#line 352 "GStreamerTagger.c"
						const gchar* _tmp6_;
						GstDiscoverer* _tmp7_;
						const gchar* _tmp8_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						if (!_tmp3_) {
#line 358 "GStreamerTagger.c"
							GeeLinkedList* _tmp4_;
							gpointer _tmp5_;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_tmp4_ = self->priv->uri_queue;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_tmp5_ = gee_deque_poll_head ((GeeDeque*) _tmp4_);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							_g_free0 (uri);
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							uri = (gchar*) _tmp5_;
#line 369 "GStreamerTagger.c"
						}
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						_tmp3_ = FALSE;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						_tmp6_ = uri;
#line 71 "../src/GStreamer/GStreamerTagger.vala"
						if (!(_tmp6_ != NULL)) {
#line 71 "../src/GStreamer/GStreamerTagger.vala"
							break;
#line 379 "GStreamerTagger.c"
						}
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						_tmp7_ = self->priv->d;
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						_tmp8_ = uri;
#line 72 "../src/GStreamer/GStreamerTagger.vala"
						gst_discoverer_discover_uri_async (_tmp7_, _tmp8_);
#line 387 "GStreamerTagger.c"
					}
				}
#line 71 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (uri);
#line 392 "GStreamerTagger.c"
			}
		}
		__finally28:
		{
			GeeLinkedList* _tmp9_;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			_tmp9_ = self->priv->uri_queue;
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 402 "GStreamerTagger.c"
		}
#line 70 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../src/GStreamer/GStreamerTagger.vala"
			return;
#line 412 "GStreamerTagger.c"
		}
	}
}

static void*
__lambda12_ (NoiseGStreamerTagger* self)
{
	void* result = NULL;
#line 84 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_import_next_file_set (self);
#line 85 "../src/GStreamer/GStreamerTagger.vala"
	result = NULL;
#line 85 "../src/GStreamer/GStreamerTagger.vala"
	return result;
#line 427 "GStreamerTagger.c"
}

static gpointer
___lambda12__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda12_ ((NoiseGStreamerTagger*) self);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	g_object_unref (self);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	return result;
#line 439 "GStreamerTagger.c"
}

void
noise_gstreamer_tagger_discoverer_import_media (NoiseGStreamerTagger* self,
                                                GeeCollection* uris)
{
	GstDiscoverer* _tmp3_;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 77 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (uris != NULL);
#line 454 "GStreamerTagger.c"
	{
		GeeLinkedList* _tmp0_;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		_tmp0_ = self->priv->uri_queue;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 461 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp1_;
#line 79 "../src/GStreamer/GStreamerTagger.vala"
			_tmp1_ = self->priv->uri_queue;
#line 79 "../src/GStreamer/GStreamerTagger.vala"
			gee_collection_add_all ((GeeCollection*) _tmp1_, uris);
#line 468 "GStreamerTagger.c"
		}
		__finally29:
		{
			GeeLinkedList* _tmp2_;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			_tmp2_ = self->priv->uri_queue;
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 477 "GStreamerTagger.c"
		}
#line 78 "../src/GStreamer/GStreamerTagger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			g_clear_error (&_inner_error0_);
#line 78 "../src/GStreamer/GStreamerTagger.vala"
			return;
#line 487 "GStreamerTagger.c"
		}
	}
#line 82 "../src/GStreamer/GStreamerTagger.vala"
	_tmp3_ = self->priv->d;
#line 82 "../src/GStreamer/GStreamerTagger.vala"
	gst_discoverer_start (_tmp3_);
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_tmp4_ = g_thread_new (NULL, ___lambda12__gthread_func, g_object_ref (self));
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_tmp5_ = _tmp4_;
#line 83 "../src/GStreamer/GStreamerTagger.vala"
	_g_thread_unref0 (_tmp5_);
#line 500 "GStreamerTagger.c"
}

static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	dup = g_new0 (GDate, 1);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	memcpy (dup, self, sizeof (GDate));
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	return dup;
#line 513 "GStreamerTagger.c"
}

static gpointer
__g_date_dup0 (gpointer self)
{
#line 221 "../src/GStreamer/GStreamerTagger.vala"
	return self ? _g_date_dup (self) : NULL;
#line 521 "GStreamerTagger.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 529 "GStreamerTagger.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 537 "GStreamerTagger.c"
}

static void
noise_gstreamer_tagger_import_media (NoiseGStreamerTagger* self,
                                     GstDiscovererInfo* info,
                                     GError* err)
{
	GCancellable* _tmp0_;
	gchar* uri = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean gstreamer_discovery_successful = FALSE;
	NoiseMedia* m = NULL;
	const gchar* _tmp14_;
	NoiseMedia* _tmp15_;
	guint64 duration = 0ULL;
	GstTagList* tags = NULL;
	GstTagList* _tmp16_;
	GstTagList* _tmp17_;
	NoiseMedia* _tmp108_;
	GList* _tmp109_;
	NoiseMedia* _tmp134_;
	NoiseMedia* _tmp135_;
	GFile* _tmp136_;
	GFile* _tmp137_;
	NoiseMedia* _tmp138_;
	time_t _tmp139_;
	NoiseMedia* _tmp140_;
	GError* _inner_error0_ = NULL;
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (info != NULL);
#line 90 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = self->priv->cancellable;
#line 90 "../src/GStreamer/GStreamerTagger.vala"
	if (g_cancellable_is_cancelled (_tmp0_)) {
#line 575 "GStreamerTagger.c"
		GstDiscoverer* _tmp1_;
#line 91 "../src/GStreamer/GStreamerTagger.vala"
		_tmp1_ = self->priv->d;
#line 91 "../src/GStreamer/GStreamerTagger.vala"
		gst_discoverer_stop (_tmp1_);
#line 581 "GStreamerTagger.c"
		{
			GeeLinkedList* _tmp2_;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			_tmp2_ = self->priv->uri_queue;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			g_rec_mutex_lock (&self->priv->__lock_uri_queue);
#line 588 "GStreamerTagger.c"
			{
				GeeLinkedList* _tmp3_;
#line 93 "../src/GStreamer/GStreamerTagger.vala"
				_tmp3_ = self->priv->uri_queue;
#line 93 "../src/GStreamer/GStreamerTagger.vala"
				gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
#line 595 "GStreamerTagger.c"
			}
			__finally30:
			{
				GeeLinkedList* _tmp4_;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				_tmp4_ = self->priv->uri_queue;
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_rec_mutex_unlock (&self->priv->__lock_uri_queue);
#line 604 "GStreamerTagger.c"
			}
#line 92 "../src/GStreamer/GStreamerTagger.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				g_clear_error (&_inner_error0_);
#line 92 "../src/GStreamer/GStreamerTagger.vala"
				return;
#line 614 "GStreamerTagger.c"
			}
		}
#line 96 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL], 0);
#line 97 "../src/GStreamer/GStreamerTagger.vala"
		return;
#line 621 "GStreamerTagger.c"
	}
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	_tmp5_ = gst_discoverer_info_get_uri (info);
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 100 "../src/GStreamer/GStreamerTagger.vala"
	uri = _tmp6_;
#line 101 "../src/GStreamer/GStreamerTagger.vala"
	gstreamer_discovery_successful = FALSE;
#line 103 "../src/GStreamer/GStreamerTagger.vala"
	switch (gst_discoverer_info_get_result (info)) {
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_OK:
#line 635 "GStreamerTagger.c"
		{
#line 105 "../src/GStreamer/GStreamerTagger.vala"
			gstreamer_discovery_successful = TRUE;
#line 106 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 641 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_URI_INVALID:
#line 645 "GStreamerTagger.c"
		{
			const gchar* _tmp7_;
#line 109 "../src/GStreamer/GStreamerTagger.vala"
			_tmp7_ = uri;
#line 109 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:109: GStreamer could not import '%s': invalid URI" \
".", _tmp7_);
#line 110 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 654 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_ERROR:
#line 658 "GStreamerTagger.c"
		{
			const gchar* _tmp8_;
			const gchar* _tmp9_;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			_tmp8_ = uri;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			_tmp9_ = err->message;
#line 113 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:113: GStreamer could not import '%s': %s", _tmp8_, _tmp9_);
#line 114 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 670 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_TIMEOUT:
#line 674 "GStreamerTagger.c"
		{
			const gchar* _tmp10_;
#line 117 "../src/GStreamer/GStreamerTagger.vala"
			_tmp10_ = uri;
#line 117 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:117: GStreamer could not import '%s': Discovery t" \
"imed out.", _tmp10_);
#line 118 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 683 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_BUSY:
#line 687 "GStreamerTagger.c"
		{
			const gchar* _tmp11_;
#line 121 "../src/GStreamer/GStreamerTagger.vala"
			_tmp11_ = uri;
#line 121 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:121: GStreamer could not import '%s': Already dis" \
"covering a file.", _tmp11_);
#line 122 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 696 "GStreamerTagger.c"
		}
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		case GST_DISCOVERER_MISSING_PLUGINS:
#line 700 "GStreamerTagger.c"
		{
			const gchar* _tmp12_;
#line 125 "../src/GStreamer/GStreamerTagger.vala"
			_tmp12_ = uri;
#line 125 "../src/GStreamer/GStreamerTagger.vala"
			g_warning ("GStreamerTagger.vala:125: GStreamer could not import '%s': Missing plu" \
"gins.", _tmp12_);
#line 132 "../src/GStreamer/GStreamerTagger.vala"
			break;
#line 709 "GStreamerTagger.c"
		}
		default:
#line 103 "../src/GStreamer/GStreamerTagger.vala"
		break;
#line 714 "GStreamerTagger.c"
	}
#line 135 "../src/GStreamer/GStreamerTagger.vala"
	if (!gstreamer_discovery_successful) {
#line 718 "GStreamerTagger.c"
		const gchar* _tmp13_;
#line 136 "../src/GStreamer/GStreamerTagger.vala"
		_tmp13_ = uri;
#line 136 "../src/GStreamer/GStreamerTagger.vala"
		g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL], 0, _tmp13_, err);
#line 137 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (uri);
#line 137 "../src/GStreamer/GStreamerTagger.vala"
		return;
#line 728 "GStreamerTagger.c"
	}
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	_tmp14_ = uri;
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	_tmp15_ = noise_media_new (_tmp14_);
#line 140 "../src/GStreamer/GStreamerTagger.vala"
	m = _tmp15_;
#line 142 "../src/GStreamer/GStreamerTagger.vala"
	duration = (guint64) gst_discoverer_info_get_duration (info);
#line 146 "../src/GStreamer/GStreamerTagger.vala"
	_tmp16_ = gst_discoverer_info_get_tags (info);
#line 146 "../src/GStreamer/GStreamerTagger.vala"
	tags = _tmp16_;
#line 148 "../src/GStreamer/GStreamerTagger.vala"
	_tmp17_ = tags;
#line 148 "../src/GStreamer/GStreamerTagger.vala"
	if (_tmp17_ != NULL) {
#line 746 "GStreamerTagger.c"
		gchar* title = NULL;
		GstTagList* _tmp18_;
		gchar* _tmp19_ = NULL;
		gboolean _tmp20_;
		gchar* artist = NULL;
		GstTagList* _tmp23_;
		gchar* _tmp24_ = NULL;
		gboolean _tmp25_;
		gchar* composer = NULL;
		GstTagList* _tmp28_;
		gchar* _tmp29_ = NULL;
		gboolean _tmp30_;
		gchar* album_artist = NULL;
		GstTagList* _tmp33_;
		gchar* _tmp34_ = NULL;
		gboolean _tmp35_;
		gchar* album = NULL;
		GstTagList* _tmp38_;
		gchar* _tmp39_ = NULL;
		gboolean _tmp40_;
		gchar* grouping = NULL;
		GstTagList* _tmp43_;
		gchar* _tmp44_ = NULL;
		gboolean _tmp45_;
		gchar* genre = NULL;
		GstTagList* _tmp48_;
		gchar* _tmp49_ = NULL;
		gboolean _tmp50_;
		gchar* comment = NULL;
		GstTagList* _tmp53_;
		gchar* _tmp54_ = NULL;
		gboolean _tmp55_;
		gchar* lyrics = NULL;
		GstTagList* _tmp58_;
		gchar* _tmp59_ = NULL;
		gboolean _tmp60_;
		guint track_number = 0U;
		GstTagList* _tmp63_;
		guint _tmp64_ = 0U;
		gboolean _tmp65_;
		guint track_count = 0U;
		GstTagList* _tmp67_;
		guint _tmp68_ = 0U;
		gboolean _tmp69_;
		guint album_number = 0U;
		GstTagList* _tmp71_;
		guint _tmp72_ = 0U;
		gboolean _tmp73_;
		guint album_count = 0U;
		GstTagList* _tmp75_;
		guint _tmp76_ = 0U;
		gboolean _tmp77_;
		guint bitrate = 0U;
		GstTagList* _tmp79_;
		guint _tmp80_ = 0U;
		gboolean _tmp81_;
		guint rating = 0U;
		GstTagList* _tmp83_;
		guint _tmp84_ = 0U;
		gboolean _tmp85_;
		GstDateTime* datetime = NULL;
		GstTagList* _tmp87_;
		GstDateTime* _tmp88_ = NULL;
		gboolean _tmp89_;
		gdouble bpm = 0.0;
		GstTagList* _tmp101_;
		gdouble _tmp102_ = 0.0;
		gboolean _tmp103_;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_tmp18_ = tags;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_tmp20_ = gst_tag_list_get_string (_tmp18_, GST_TAG_TITLE, &_tmp19_);
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		title = _tmp19_;
#line 151 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp20_) {
#line 825 "GStreamerTagger.c"
			NoiseMedia* _tmp21_;
			const gchar* _tmp22_;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			_tmp21_ = m;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			_tmp22_ = title;
#line 152 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_title (_tmp21_, _tmp22_);
#line 834 "GStreamerTagger.c"
		}
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_tmp23_ = tags;
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_tmp25_ = gst_tag_list_get_string (_tmp23_, GST_TAG_ARTIST, &_tmp24_);
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		artist = _tmp24_;
#line 155 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp25_) {
#line 846 "GStreamerTagger.c"
			NoiseMedia* _tmp26_;
			const gchar* _tmp27_;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			_tmp26_ = m;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			_tmp27_ = artist;
#line 156 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_artist (_tmp26_, _tmp27_);
#line 855 "GStreamerTagger.c"
		}
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_tmp28_ = tags;
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_tmp30_ = gst_tag_list_get_string (_tmp28_, GST_TAG_COMPOSER, &_tmp29_);
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		composer = _tmp29_;
#line 159 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp30_) {
#line 867 "GStreamerTagger.c"
			NoiseMedia* _tmp31_;
			const gchar* _tmp32_;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			_tmp31_ = m;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			_tmp32_ = composer;
#line 160 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_composer (_tmp31_, _tmp32_);
#line 876 "GStreamerTagger.c"
		}
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_tmp33_ = tags;
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_tmp35_ = gst_tag_list_get_string (_tmp33_, GST_TAG_ALBUM_ARTIST, &_tmp34_);
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		album_artist = _tmp34_;
#line 163 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp35_) {
#line 888 "GStreamerTagger.c"
			NoiseMedia* _tmp36_;
			const gchar* _tmp37_;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			_tmp36_ = m;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			_tmp37_ = album_artist;
#line 164 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_artist (_tmp36_, _tmp37_);
#line 897 "GStreamerTagger.c"
		}
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_tmp38_ = tags;
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_tmp40_ = gst_tag_list_get_string (_tmp38_, GST_TAG_ALBUM, &_tmp39_);
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		album = _tmp39_;
#line 167 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp40_) {
#line 909 "GStreamerTagger.c"
			NoiseMedia* _tmp41_;
			const gchar* _tmp42_;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			_tmp41_ = m;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			_tmp42_ = album;
#line 168 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album (_tmp41_, _tmp42_);
#line 918 "GStreamerTagger.c"
		}
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_tmp43_ = tags;
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_tmp45_ = gst_tag_list_get_string (_tmp43_, GST_TAG_GROUPING, &_tmp44_);
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		grouping = _tmp44_;
#line 171 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp45_) {
#line 930 "GStreamerTagger.c"
			NoiseMedia* _tmp46_;
			const gchar* _tmp47_;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			_tmp46_ = m;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			_tmp47_ = grouping;
#line 172 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_grouping (_tmp46_, _tmp47_);
#line 939 "GStreamerTagger.c"
		}
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_tmp48_ = tags;
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_tmp50_ = gst_tag_list_get_string (_tmp48_, GST_TAG_GENRE, &_tmp49_);
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		genre = _tmp49_;
#line 175 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp50_) {
#line 951 "GStreamerTagger.c"
			NoiseMedia* _tmp51_;
			const gchar* _tmp52_;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			_tmp51_ = m;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			_tmp52_ = genre;
#line 176 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_genre (_tmp51_, _tmp52_);
#line 960 "GStreamerTagger.c"
		}
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_tmp53_ = tags;
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_tmp55_ = gst_tag_list_get_string (_tmp53_, GST_TAG_COMMENT, &_tmp54_);
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		comment = _tmp54_;
#line 179 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp55_) {
#line 972 "GStreamerTagger.c"
			NoiseMedia* _tmp56_;
			const gchar* _tmp57_;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			_tmp56_ = m;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			_tmp57_ = comment;
#line 180 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_comment (_tmp56_, _tmp57_);
#line 981 "GStreamerTagger.c"
		}
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_tmp58_ = tags;
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_tmp60_ = gst_tag_list_get_string (_tmp58_, GST_TAG_LYRICS, &_tmp59_);
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		lyrics = _tmp59_;
#line 183 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp60_) {
#line 993 "GStreamerTagger.c"
			NoiseMedia* _tmp61_;
			const gchar* _tmp62_;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			_tmp61_ = m;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			_tmp62_ = lyrics;
#line 184 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_lyrics (_tmp61_, _tmp62_);
#line 1002 "GStreamerTagger.c"
		}
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		_tmp63_ = tags;
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		_tmp65_ = gst_tag_list_get_uint (_tmp63_, GST_TAG_TRACK_NUMBER, &_tmp64_);
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		track_number = _tmp64_;
#line 187 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp65_) {
#line 1012 "GStreamerTagger.c"
			NoiseMedia* _tmp66_;
#line 188 "../src/GStreamer/GStreamerTagger.vala"
			_tmp66_ = m;
#line 188 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track (_tmp66_, track_number);
#line 1018 "GStreamerTagger.c"
		}
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		_tmp67_ = tags;
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		_tmp69_ = gst_tag_list_get_uint (_tmp67_, GST_TAG_TRACK_COUNT, &_tmp68_);
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		track_count = _tmp68_;
#line 191 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp69_) {
#line 1028 "GStreamerTagger.c"
			NoiseMedia* _tmp70_;
#line 192 "../src/GStreamer/GStreamerTagger.vala"
			_tmp70_ = m;
#line 192 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_track_count (_tmp70_, track_count);
#line 1034 "GStreamerTagger.c"
		}
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		_tmp71_ = tags;
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		_tmp73_ = gst_tag_list_get_uint (_tmp71_, GST_TAG_ALBUM_VOLUME_NUMBER, &_tmp72_);
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		album_number = _tmp72_;
#line 195 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp73_) {
#line 1044 "GStreamerTagger.c"
			NoiseMedia* _tmp74_;
#line 196 "../src/GStreamer/GStreamerTagger.vala"
			_tmp74_ = m;
#line 196 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_number (_tmp74_, album_number);
#line 1050 "GStreamerTagger.c"
		}
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		_tmp75_ = tags;
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		_tmp77_ = gst_tag_list_get_uint (_tmp75_, GST_TAG_ALBUM_VOLUME_COUNT, &_tmp76_);
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		album_count = _tmp76_;
#line 199 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp77_) {
#line 1060 "GStreamerTagger.c"
			NoiseMedia* _tmp78_;
#line 200 "../src/GStreamer/GStreamerTagger.vala"
			_tmp78_ = m;
#line 200 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_album_count (_tmp78_, album_count);
#line 1066 "GStreamerTagger.c"
		}
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		_tmp79_ = tags;
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		_tmp81_ = gst_tag_list_get_uint (_tmp79_, GST_TAG_BITRATE, &_tmp80_);
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		bitrate = _tmp80_;
#line 203 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp81_) {
#line 1076 "GStreamerTagger.c"
			NoiseMedia* _tmp82_;
#line 204 "../src/GStreamer/GStreamerTagger.vala"
			_tmp82_ = m;
#line 204 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bitrate (_tmp82_, bitrate / 1000);
#line 1082 "GStreamerTagger.c"
		}
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		_tmp83_ = tags;
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		_tmp85_ = gst_tag_list_get_uint (_tmp83_, GST_TAG_USER_RATING, &_tmp84_);
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		rating = _tmp84_;
#line 207 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp85_) {
#line 1092 "GStreamerTagger.c"
			NoiseMedia* _tmp86_;
#line 208 "../src/GStreamer/GStreamerTagger.vala"
			_tmp86_ = m;
#line 208 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_rating (_tmp86_, rating);
#line 1098 "GStreamerTagger.c"
		}
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_tmp87_ = tags;
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_tmp89_ = gst_tag_list_get_date_time (_tmp87_, GST_TAG_DATE_TIME, &_tmp88_);
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		datetime = _tmp88_;
#line 214 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp89_) {
#line 1110 "GStreamerTagger.c"
			GstDateTime* _tmp90_;
#line 217 "../src/GStreamer/GStreamerTagger.vala"
			_tmp90_ = datetime;
#line 217 "../src/GStreamer/GStreamerTagger.vala"
			if (_tmp90_ != NULL) {
#line 1116 "GStreamerTagger.c"
				NoiseMedia* _tmp91_;
				GstDateTime* _tmp92_;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				_tmp91_ = m;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				_tmp92_ = datetime;
#line 218 "../src/GStreamer/GStreamerTagger.vala"
				noise_media_set_year (_tmp91_, (guint) gst_date_time_get_year (_tmp92_));
#line 1125 "GStreamerTagger.c"
			} else {
				GDate* date = NULL;
				GstTagList* _tmp93_;
				GDate _tmp94_ = {0};
				gboolean _tmp95_;
				GDate _tmp96_;
				GDate* _tmp97_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp93_ = tags;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp95_ = gst_tag_list_get_date (_tmp93_, GST_TAG_DATE, &_tmp94_);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp96_ = _tmp94_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				_tmp97_ = __g_date_dup0 (&_tmp96_);
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				date = _tmp97_;
#line 221 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp95_) {
#line 1147 "GStreamerTagger.c"
					GDate* _tmp98_;
#line 224 "../src/GStreamer/GStreamerTagger.vala"
					_tmp98_ = date;
#line 224 "../src/GStreamer/GStreamerTagger.vala"
					if (_tmp98_ != NULL) {
#line 1153 "GStreamerTagger.c"
						NoiseMedia* _tmp99_;
						GDate* _tmp100_;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						_tmp99_ = m;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						_tmp100_ = date;
#line 225 "../src/GStreamer/GStreamerTagger.vala"
						noise_media_set_year (_tmp99_, (guint) g_date_get_year (_tmp100_));
#line 1162 "GStreamerTagger.c"
					}
				}
#line 217 "../src/GStreamer/GStreamerTagger.vala"
				_g_free0 (date);
#line 1167 "GStreamerTagger.c"
			}
		}
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		_tmp101_ = tags;
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		_tmp103_ = gst_tag_list_get_double (_tmp101_, GST_TAG_BEATS_PER_MINUTE, &_tmp102_);
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		bpm = _tmp102_;
#line 232 "../src/GStreamer/GStreamerTagger.vala"
		if (_tmp103_) {
#line 1178 "GStreamerTagger.c"
			NoiseMedia* _tmp104_;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			_tmp104_ = m;
#line 233 "../src/GStreamer/GStreamerTagger.vala"
			noise_media_set_bpm (_tmp104_, (guint) CLAMP (bpm, (gdouble) 0, bpm));
#line 1184 "GStreamerTagger.c"
		}
#line 235 "../src/GStreamer/GStreamerTagger.vala"
		if (duration == ((guint64) 0)) {
#line 1188 "GStreamerTagger.c"
			GstTagList* _tmp105_;
			guint64 _tmp106_ = 0ULL;
			gboolean _tmp107_;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			_tmp105_ = tags;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			_tmp107_ = gst_tag_list_get_uint64 (_tmp105_, GST_TAG_DURATION, &_tmp106_);
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			duration = _tmp106_;
#line 236 "../src/GStreamer/GStreamerTagger.vala"
			if (!_tmp107_) {
#line 237 "../src/GStreamer/GStreamerTagger.vala"
				duration = (guint64) 0;
#line 1202 "GStreamerTagger.c"
			}
		}
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_gst_date_time_unref0 (datetime);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (lyrics);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (comment);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (genre);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (grouping);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (album_artist);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (composer);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (artist);
#line 148 "../src/GStreamer/GStreamerTagger.vala"
		_g_free0 (title);
#line 1225 "GStreamerTagger.c"
	}
#line 240 "../src/GStreamer/GStreamerTagger.vala"
	_tmp108_ = m;
#line 240 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_length (_tmp108_, noise_time_utils_nanoseconds_to_miliseconds (duration));
#line 241 "../src/GStreamer/GStreamerTagger.vala"
	_tmp109_ = gst_discoverer_info_get_audio_streams (info);
#line 1233 "GStreamerTagger.c"
	{
		GList* stream_info_collection = NULL;
		GList* stream_info_it = NULL;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		stream_info_collection = _tmp109_;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		for (stream_info_it = stream_info_collection; stream_info_it != NULL; stream_info_it = stream_info_it->next) {
#line 1241 "GStreamerTagger.c"
			GstDiscovererStreamInfo* _tmp110_;
			GstDiscovererStreamInfo* stream_info = NULL;
#line 241 "../src/GStreamer/GStreamerTagger.vala"
			_tmp110_ = _g_object_ref0 ((GstDiscovererStreamInfo*) stream_info_it->data);
#line 241 "../src/GStreamer/GStreamerTagger.vala"
			stream_info = _tmp110_;
#line 1248 "GStreamerTagger.c"
			{
				GstDiscovererAudioInfo* audio_stream = NULL;
				GstDiscovererStreamInfo* _tmp111_;
				GstDiscovererAudioInfo* _tmp112_;
				GstDiscovererAudioInfo* _tmp113_;
				NoiseMedia* _tmp114_;
				guint _tmp115_;
				guint _tmp116_;
				NoiseMedia* _tmp124_;
				guint _tmp125_;
				guint _tmp126_;
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				_tmp111_ = stream_info;
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				_tmp112_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp111_, gst_discoverer_audio_info_get_type ()) ? ((GstDiscovererAudioInfo*) _tmp111_) : NULL);
#line 242 "../src/GStreamer/GStreamerTagger.vala"
				audio_stream = _tmp112_;
#line 243 "../src/GStreamer/GStreamerTagger.vala"
				_tmp113_ = audio_stream;
#line 243 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp113_ == NULL) {
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (audio_stream);
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					_g_object_unref0 (stream_info);
#line 244 "../src/GStreamer/GStreamerTagger.vala"
					continue;
#line 1276 "GStreamerTagger.c"
				}
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp114_ = m;
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp115_ = noise_media_get_samplerate (_tmp114_);
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				_tmp116_ = _tmp115_;
#line 246 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp116_ == ((guint) 0)) {
#line 1286 "GStreamerTagger.c"
					NoiseMedia* _tmp117_;
					GstDiscovererAudioInfo* _tmp118_;
					NoiseMedia* _tmp119_;
					guint _tmp120_;
					guint _tmp121_;
					gchar* _tmp122_;
					gchar* _tmp123_;
#line 247 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:247: Getting sample rate from stream info");
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					_tmp117_ = m;
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					_tmp118_ = audio_stream;
#line 248 "../src/GStreamer/GStreamerTagger.vala"
					noise_media_set_samplerate (_tmp117_, gst_discoverer_audio_info_get_sample_rate (_tmp118_));
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp119_ = m;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp120_ = noise_media_get_samplerate (_tmp119_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp121_ = _tmp120_;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp122_ = g_strdup_printf ("%u", _tmp121_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_tmp123_ = _tmp122_;
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:249: Sample rate = %s", _tmp123_);
#line 249 "../src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp123_);
#line 1316 "GStreamerTagger.c"
				}
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp124_ = m;
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp125_ = noise_media_get_bitrate (_tmp124_);
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				_tmp126_ = _tmp125_;
#line 252 "../src/GStreamer/GStreamerTagger.vala"
				if (_tmp126_ == ((guint) 0)) {
#line 1326 "GStreamerTagger.c"
					NoiseMedia* _tmp127_;
					GstDiscovererAudioInfo* _tmp128_;
					NoiseMedia* _tmp129_;
					guint _tmp130_;
					guint _tmp131_;
					gchar* _tmp132_;
					gchar* _tmp133_;
#line 253 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:253: Getting bitrate from stream info");
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					_tmp127_ = m;
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					_tmp128_ = audio_stream;
#line 254 "../src/GStreamer/GStreamerTagger.vala"
					noise_media_set_bitrate (_tmp127_, gst_discoverer_audio_info_get_bitrate (_tmp128_));
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp129_ = m;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp130_ = noise_media_get_bitrate (_tmp129_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp131_ = _tmp130_;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp132_ = g_strdup_printf ("%u", _tmp131_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_tmp133_ = _tmp132_;
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					g_debug ("GStreamerTagger.vala:255: Bitrate = %s", _tmp133_);
#line 255 "../src/GStreamer/GStreamerTagger.vala"
					_g_free0 (_tmp133_);
#line 1356 "GStreamerTagger.c"
				}
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (audio_stream);
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				_g_object_unref0 (stream_info);
#line 258 "../src/GStreamer/GStreamerTagger.vala"
				break;
#line 1364 "GStreamerTagger.c"
			}
		}
#line 241 "../src/GStreamer/GStreamerTagger.vala"
		(stream_info_collection == NULL) ? NULL : (stream_info_collection = (_g_list_free__g_object_unref0_ (stream_info_collection), NULL));
#line 1369 "GStreamerTagger.c"
	}
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp134_ = m;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp135_ = m;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp136_ = noise_media_get_file (_tmp135_);
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	_tmp137_ = _tmp136_;
#line 261 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_file_size (_tmp134_, noise_file_utils_get_size (_tmp137_, NULL));
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	_tmp138_ = m;
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	_tmp139_ = time (NULL);
#line 262 "../src/GStreamer/GStreamerTagger.vala"
	noise_media_set_date_added (_tmp138_, (guint) ((gint) _tmp139_));
#line 263 "../src/GStreamer/GStreamerTagger.vala"
	_tmp140_ = m;
#line 263 "../src/GStreamer/GStreamerTagger.vala"
	g_signal_emit (self, noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL], 0, _tmp140_);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (m);
#line 89 "../src/GStreamer/GStreamerTagger.vala"
	_g_free0 (uri);
#line 1395 "GStreamerTagger.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_POINTER (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_POINTER) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data1 = closure->data;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data2 = param_values->data[0].v_pointer;
#line 1420 "GStreamerTagger.c"
	} else {
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
		data2 = closure->data;
#line 1426 "GStreamerTagger.c"
	}
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	callback = (GMarshalFunc_VOID__STRING_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 1432 "GStreamerTagger.c"
}

static void
noise_gstreamer_tagger_class_init (NoiseGStreamerTaggerClass * klass,
                                   gpointer klass_data)
{
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	g_type_class_adjust_private_offset (klass, &NoiseGStreamerTagger_private_offset);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_gstreamer_tagger_finalize;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_MEDIA_IMPORTED_SIGNAL] = g_signal_new ("media-imported", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NOISE_TYPE_MEDIA);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_IMPORT_ERROR_SIGNAL] = g_signal_new ("import-error", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_POINTER, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_POINTER);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	noise_gstreamer_tagger_signals[NOISE_GSTREAMER_TAGGER_QUEUE_FINISHED_SIGNAL] = g_signal_new ("queue-finished", NOISE_TYPE_GSTREAMER_TAGGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1451 "GStreamerTagger.c"
}

static void
noise_gstreamer_tagger_instance_init (NoiseGStreamerTagger * self,
                                      gpointer klass)
{
	GeeLinkedList* _tmp0_;
	GCancellable* _tmp1_;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	self->priv = noise_gstreamer_tagger_get_instance_private (self);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_init (&self->priv->__lock_uri_queue);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->uri_queue = _tmp0_;
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	_tmp1_ = g_cancellable_new ();
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	self->priv->cancellable = _tmp1_;
#line 1472 "GStreamerTagger.c"
}

static void
noise_gstreamer_tagger_finalize (GObject * obj)
{
	NoiseGStreamerTagger * self;
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_GSTREAMER_TAGGER, NoiseGStreamerTagger);
#line 37 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->d);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	g_rec_mutex_clear (&self->priv->__lock_uri_queue);
#line 38 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->uri_queue);
#line 39 "../src/GStreamer/GStreamerTagger.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 30 "../src/GStreamer/GStreamerTagger.vala"
	G_OBJECT_CLASS (noise_gstreamer_tagger_parent_class)->finalize (obj);
#line 1491 "GStreamerTagger.c"
}

GType
noise_gstreamer_tagger_get_type (void)
{
	static volatile gsize noise_gstreamer_tagger_type_id__volatile = 0;
	if (g_once_init_enter (&noise_gstreamer_tagger_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseGStreamerTaggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_gstreamer_tagger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseGStreamerTagger), 0, (GInstanceInitFunc) noise_gstreamer_tagger_instance_init, NULL };
		GType noise_gstreamer_tagger_type_id;
		noise_gstreamer_tagger_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseGStreamerTagger", &g_define_type_info, 0);
		NoiseGStreamerTagger_private_offset = g_type_add_instance_private (noise_gstreamer_tagger_type_id, sizeof (NoiseGStreamerTaggerPrivate));
		g_once_init_leave (&noise_gstreamer_tagger_type_id__volatile, noise_gstreamer_tagger_type_id);
	}
	return noise_gstreamer_tagger_type_id__volatile;
}

