/* SimilarMediaView.c generated by valac 0.44.0, the Vala compiler
 * generated from SimilarMediaView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>,
 *              Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>

#define NOISE_TYPE_SIMILAR_MEDIAS_VIEW (noise_similar_medias_view_get_type ())
#define NOISE_SIMILAR_MEDIAS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasView))
#define NOISE_SIMILAR_MEDIAS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasViewClass))
#define NOISE_IS_SIMILAR_MEDIAS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW))
#define NOISE_IS_SIMILAR_MEDIAS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_SIMILAR_MEDIAS_VIEW))
#define NOISE_SIMILAR_MEDIAS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasViewClass))

typedef struct _NoiseSimilarMediasView NoiseSimilarMediasView;
typedef struct _NoiseSimilarMediasViewClass NoiseSimilarMediasViewClass;
typedef struct _NoiseSimilarMediasViewPrivate NoiseSimilarMediasViewPrivate;
enum  {
	NOISE_SIMILAR_MEDIAS_VIEW_0_PROPERTY,
	NOISE_SIMILAR_MEDIAS_VIEW_NUM_PROPERTIES
};
static GParamSpec* noise_similar_medias_view_properties[NOISE_SIMILAR_MEDIAS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseSimilarMediasView {
	GtkTreeView parent_instance;
	NoiseSimilarMediasViewPrivate * priv;
};

struct _NoiseSimilarMediasViewClass {
	GtkTreeViewClass parent_class;
	void (*viewDoubleClick) (NoiseSimilarMediasView* self, GtkTreePath* path, GtkTreeViewColumn* column);
};

struct _NoiseSimilarMediasViewPrivate {
	GtkListStore* model;
	GeeLinkedList* medias;
	GeeLinkedList* urlsToOpen;
};

static gint NoiseSimilarMediasView_private_offset;
static gpointer noise_similar_medias_view_parent_class = NULL;
static GType noise_similar_medias_view_type_id = 0;

GType noise_similar_medias_view_register_type (GTypeModule * module);
GType noise_similar_medias_view_get_type (void) G_GNUC_CONST;
NoiseSimilarMediasView* noise_similar_medias_view_new (void);
NoiseSimilarMediasView* noise_similar_medias_view_construct (GType object_type);
void noise_similar_medias_view_viewDoubleClick (NoiseSimilarMediasView* self,
                                                GtkTreePath* path,
                                                GtkTreeViewColumn* column);
static void _noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                             GtkTreePath* path,
                                                                             GtkTreeViewColumn* column,
                                                                             gpointer self);
void noise_similar_medias_view_populateView (NoiseSimilarMediasView* self,
                                             GeeCollection* nMedias);
static void noise_similar_medias_view_real_viewDoubleClick (NoiseSimilarMediasView* self,
                                                     GtkTreePath* path,
                                                     GtkTreeViewColumn* column);
void* noise_similar_medias_view_take_action (NoiseSimilarMediasView* self);
static gpointer _noise_similar_medias_view_take_action_gthread_func (gpointer self);
static void noise_similar_medias_view_finalize (GObject * obj);

static inline gpointer
noise_similar_medias_view_get_instance_private (NoiseSimilarMediasView* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseSimilarMediasView_private_offset);
}

static void
_noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated (GtkTreeView* _sender,
                                                                        GtkTreePath* path,
                                                                        GtkTreeViewColumn* column,
                                                                        gpointer self)
{
#line 57 "../plugins/LastFM/SimilarMediaView.vala"
	noise_similar_medias_view_viewDoubleClick ((NoiseSimilarMediasView*) self, path, column);
#line 121 "SimilarMediaView.c"
}

NoiseSimilarMediasView*
noise_similar_medias_view_construct (GType object_type)
{
	NoiseSimilarMediasView * self = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GtkListStore* _tmp2_;
	GtkTreeViewColumn* col = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	GtkListStore* _tmp6_;
#line 36 "../plugins/LastFM/SimilarMediaView.vala"
	self = (NoiseSimilarMediasView*) g_object_new (object_type, NULL);
#line 37 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp0_ = gee_linked_list_new (NOISE_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 37 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->medias);
#line 37 "../plugins/LastFM/SimilarMediaView.vala"
	self->priv->medias = _tmp0_;
#line 38 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 38 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->urlsToOpen);
#line 38 "../plugins/LastFM/SimilarMediaView.vala"
	self->priv->urlsToOpen = _tmp1_;
#line 45 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp2_ = gtk_list_store_new (2, NOISE_TYPE_MEDIA, G_TYPE_STRING, -1);
#line 45 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->model);
#line 45 "../plugins/LastFM/SimilarMediaView.vala"
	self->priv->model = _tmp2_;
#line 47 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp3_ = gtk_tree_view_column_new ();
#line 47 "../plugins/LastFM/SimilarMediaView.vala"
	g_object_ref_sink (_tmp3_);
#line 47 "../plugins/LastFM/SimilarMediaView.vala"
	col = _tmp3_;
#line 48 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_column_set_title (col, _ ("media"));
#line 49 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_column_set_visible (col, FALSE);
#line 50 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_insert_column ((GtkTreeView*) self, col, 0);
#line 52 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp4_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 52 "../plugins/LastFM/SimilarMediaView.vala"
	g_object_ref_sink (_tmp4_);
#line 52 "../plugins/LastFM/SimilarMediaView.vala"
	text_renderer = _tmp4_;
#line 53 "../plugins/LastFM/SimilarMediaView.vala"
	g_object_set (text_renderer, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 54 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_insert_column_with_attributes ((GtkTreeView*) self, -1, _ ("Similar Media"), (GtkCellRenderer*) text_renderer, "markup", 1, NULL, NULL);
#line 55 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp5_ = gtk_tree_view_get_column ((GtkTreeView*) self, 1);
#line 55 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_column_set_alignment (_tmp5_, (gfloat) 0.5);
#line 56 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp6_ = self->priv->model;
#line 56 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp6_);
#line 57 "../plugins/LastFM/SimilarMediaView.vala"
	g_signal_connect_object ((GtkTreeView*) self, "row-activated", (GCallback) _noise_similar_medias_view_viewDoubleClick_gtk_tree_view_row_activated, self, 0);
#line 36 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (text_renderer);
#line 36 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (col);
#line 36 "../plugins/LastFM/SimilarMediaView.vala"
	return self;
#line 195 "SimilarMediaView.c"
}

NoiseSimilarMediasView*
noise_similar_medias_view_new (void)
{
#line 36 "../plugins/LastFM/SimilarMediaView.vala"
	return noise_similar_medias_view_construct (NOISE_TYPE_SIMILAR_MEDIAS_VIEW);
#line 203 "SimilarMediaView.c"
}

void
noise_similar_medias_view_populateView (NoiseSimilarMediasView* self,
                                        GeeCollection* nMedias)
{
	GeeLinkedList* _tmp0_;
	GtkListStore* _tmp1_;
	gint count = 0;
#line 60 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_if_fail (self != NULL);
#line 60 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_if_fail (nMedias != NULL);
#line 61 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp0_ = self->priv->medias;
#line 61 "../plugins/LastFM/SimilarMediaView.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 62 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp1_ = self->priv->model;
#line 62 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_list_store_clear (_tmp1_);
#line 63 "../plugins/LastFM/SimilarMediaView.vala"
	count = 0;
#line 227 "SimilarMediaView.c"
	{
		GeeIterator* _s_it = NULL;
		GeeIterator* _tmp2_;
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) nMedias);
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
		_s_it = _tmp2_;
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
		while (TRUE) {
#line 237 "SimilarMediaView.c"
			GeeIterator* _tmp3_;
			NoiseMedia* s = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GeeLinkedList* _tmp6_;
			NoiseMedia* _tmp7_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp8_;
			GtkTreeIter _tmp9_ = {0};
			gchar* title_fixed = NULL;
			NoiseMedia* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* artist_fixed = NULL;
			NoiseMedia* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			GtkListStore* _tmp18_;
			GtkTreeIter _tmp19_;
			NoiseMedia* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp3_ = _s_it;
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
				break;
#line 270 "SimilarMediaView.c"
			}
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp4_ = _s_it;
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			s = (NoiseMedia*) _tmp5_;
#line 65 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp6_ = self->priv->medias;
#line 65 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp7_ = s;
#line 65 "../plugins/LastFM/SimilarMediaView.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 68 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp8_ = self->priv->model;
#line 68 "../plugins/LastFM/SimilarMediaView.vala"
			gtk_list_store_append (_tmp8_, &_tmp9_);
#line 68 "../plugins/LastFM/SimilarMediaView.vala"
			iter = _tmp9_;
#line 70 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp10_ = s;
#line 70 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp11_ = noise_media_get_title (_tmp10_);
#line 70 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp12_ = _tmp11_;
#line 70 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp13_ = g_markup_escape_text (_tmp12_, (gssize) -1);
#line 70 "../plugins/LastFM/SimilarMediaView.vala"
			title_fixed = _tmp13_;
#line 71 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp14_ = s;
#line 71 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp15_ = noise_media_get_artist (_tmp14_);
#line 71 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp16_ = _tmp15_;
#line 71 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
#line 71 "../plugins/LastFM/SimilarMediaView.vala"
			artist_fixed = _tmp17_;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp18_ = self->priv->model;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp19_ = iter;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp20_ = s;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp21_ = title_fixed;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp22_ = artist_fixed;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp23_ = g_strdup_printf ("<b>%s</b>\n%s", _tmp21_, _tmp22_);
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp24_ = _tmp23_;
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			gtk_list_store_set (_tmp18_, &_tmp19_, 0, _tmp20_, 1, _tmp24_, -1);
#line 73 "../plugins/LastFM/SimilarMediaView.vala"
			_g_free0 (_tmp24_);
#line 74 "../plugins/LastFM/SimilarMediaView.vala"
			count = count + 1;
#line 76 "../plugins/LastFM/SimilarMediaView.vala"
			if (count >= 16) {
#line 77 "../plugins/LastFM/SimilarMediaView.vala"
				_g_free0 (artist_fixed);
#line 77 "../plugins/LastFM/SimilarMediaView.vala"
				_g_free0 (title_fixed);
#line 77 "../plugins/LastFM/SimilarMediaView.vala"
				_g_object_unref0 (s);
#line 77 "../plugins/LastFM/SimilarMediaView.vala"
				_g_object_unref0 (_s_it);
#line 77 "../plugins/LastFM/SimilarMediaView.vala"
				return;
#line 342 "SimilarMediaView.c"
			}
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_g_free0 (artist_fixed);
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_g_free0 (title_fixed);
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
			_g_object_unref0 (s);
#line 350 "SimilarMediaView.c"
		}
#line 64 "../plugins/LastFM/SimilarMediaView.vala"
		_g_object_unref0 (_s_it);
#line 354 "SimilarMediaView.c"
	}
}

static gpointer
_noise_similar_medias_view_take_action_gthread_func (gpointer self)
{
	gpointer result;
	result = noise_similar_medias_view_take_action ((NoiseSimilarMediasView*) self);
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
	g_object_unref (self);
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
	return result;
#line 367 "SimilarMediaView.c"
}

static void
noise_similar_medias_view_real_viewDoubleClick (NoiseSimilarMediasView* self,
                                                GtkTreePath* path,
                                                GtkTreeViewColumn* column)
{
	GError* _inner_error0_ = NULL;
#line 81 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_if_fail (path != NULL);
#line 81 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_if_fail (column != NULL);
#line 380 "SimilarMediaView.c"
	{
		GThread* _tmp0_;
		GThread* _tmp1_;
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp0_ = g_thread_try_new (NULL, _noise_similar_medias_view_take_action_gthread_func, g_object_ref (self), &_inner_error0_);
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp1_ = _tmp0_;
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
		_g_thread_unref0 (_tmp1_);
#line 83 "../plugins/LastFM/SimilarMediaView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "SimilarMediaView.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		err = _inner_error0_;
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		_inner_error0_ = NULL;
#line 85 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp2_ = err;
#line 85 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp3_ = _tmp2_->message;
#line 85 "../plugins/LastFM/SimilarMediaView.vala"
		g_warning ("SimilarMediaView.vala:85: ERROR: Could not create thread to have fun: " \
"%s", _tmp3_);
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		_g_error_free0 (err);
#line 414 "SimilarMediaView.c"
	}
	__finally4:
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		g_clear_error (&_inner_error0_);
#line 82 "../plugins/LastFM/SimilarMediaView.vala"
		return;
#line 425 "SimilarMediaView.c"
	}
}

void
noise_similar_medias_view_viewDoubleClick (NoiseSimilarMediasView* self,
                                           GtkTreePath* path,
                                           GtkTreeViewColumn* column)
{
#line 81 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_if_fail (self != NULL);
#line 81 "../plugins/LastFM/SimilarMediaView.vala"
	NOISE_SIMILAR_MEDIAS_VIEW_GET_CLASS (self)->viewDoubleClick (self, path, column);
#line 438 "SimilarMediaView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	return self ? g_object_ref (self) : NULL;
#line 446 "SimilarMediaView.c"
}

void*
noise_similar_medias_view_take_action (NoiseSimilarMediasView* self)
{
	void* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreeModel* mo = NULL;
	NoiseMedia* s = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreeIter _tmp2_ = {0};
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeIter _tmp5_;
	NoiseMedia* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	NoiseMedia* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 89 "../plugins/LastFM/SimilarMediaView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_selection_get_selected (_tmp0_, &_tmp1_, &_tmp2_);
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (mo);
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp3_ = _g_object_ref0 (_tmp1_);
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	mo = _tmp3_;
#line 94 "../plugins/LastFM/SimilarMediaView.vala"
	iter = _tmp2_;
#line 95 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp4_ = mo;
#line 95 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp5_ = iter;
#line 95 "../plugins/LastFM/SimilarMediaView.vala"
	gtk_tree_model_get (_tmp4_, &_tmp5_, 0, &_tmp6_, -1);
#line 95 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (s);
#line 95 "../plugins/LastFM/SimilarMediaView.vala"
	s = _tmp6_;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
	_tmp9_ = s;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
	if (_tmp9_ != NULL) {
#line 495 "SimilarMediaView.c"
		NoiseMedia* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp10_ = s;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp11_ = noise_media_get_comment (_tmp10_);
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp12_ = _tmp11_;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp8_ = _tmp12_ != NULL;
#line 507 "SimilarMediaView.c"
	} else {
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp8_ = FALSE;
#line 511 "SimilarMediaView.c"
	}
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
	if (_tmp8_) {
#line 515 "SimilarMediaView.c"
		NoiseMedia* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp13_ = s;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp14_ = noise_media_get_comment (_tmp13_);
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp15_ = _tmp14_;
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp7_ = g_strcmp0 (_tmp15_, "") != 0;
#line 527 "SimilarMediaView.c"
	} else {
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
		_tmp7_ = FALSE;
#line 531 "SimilarMediaView.c"
	}
#line 98 "../plugins/LastFM/SimilarMediaView.vala"
	if (_tmp7_) {
#line 535 "SimilarMediaView.c"
		{
			NoiseMedia* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 100 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp16_ = s;
#line 100 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp17_ = noise_media_get_comment (_tmp16_);
#line 100 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp18_ = _tmp17_;
#line 100 "../plugins/LastFM/SimilarMediaView.vala"
			g_app_info_launch_default_for_uri (_tmp18_, NULL, &_inner_error0_);
#line 100 "../plugins/LastFM/SimilarMediaView.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 550 "SimilarMediaView.c"
				goto __catch5_g_error;
			}
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* err = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			err = _inner_error0_;
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			_inner_error0_ = NULL;
#line 102 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp19_ = err;
#line 102 "../plugins/LastFM/SimilarMediaView.vala"
			_tmp20_ = _tmp19_->message;
#line 102 "../plugins/LastFM/SimilarMediaView.vala"
			g_message ("SimilarMediaView.vala:102: Couldn't open the similar media's last fm p" \
"age: %s", _tmp20_);
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			_g_error_free0 (err);
#line 572 "SimilarMediaView.c"
		}
		__finally5:
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			_g_object_unref0 (s);
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			_g_object_unref0 (mo);
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			g_clear_error (&_inner_error0_);
#line 99 "../plugins/LastFM/SimilarMediaView.vala"
			return NULL;
#line 587 "SimilarMediaView.c"
		}
	}
#line 106 "../plugins/LastFM/SimilarMediaView.vala"
	result = NULL;
#line 106 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (s);
#line 106 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (mo);
#line 106 "../plugins/LastFM/SimilarMediaView.vala"
	return result;
#line 598 "SimilarMediaView.c"
}

static void
noise_similar_medias_view_class_init (NoiseSimilarMediasViewClass * klass,
                                      gpointer klass_data)
{
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	noise_similar_medias_view_parent_class = g_type_class_peek_parent (klass);
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	g_type_class_adjust_private_offset (klass, &NoiseSimilarMediasView_private_offset);
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	((NoiseSimilarMediasViewClass *) klass)->viewDoubleClick = (void (*) (NoiseSimilarMediasView*, GtkTreePath*, GtkTreeViewColumn*)) noise_similar_medias_view_real_viewDoubleClick;
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_similar_medias_view_finalize;
#line 613 "SimilarMediaView.c"
}

static void
noise_similar_medias_view_instance_init (NoiseSimilarMediasView * self,
                                         gpointer klass)
{
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	self->priv = noise_similar_medias_view_get_instance_private (self);
#line 622 "SimilarMediaView.c"
}

static void
noise_similar_medias_view_finalize (GObject * obj)
{
	NoiseSimilarMediasView * self;
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_SIMILAR_MEDIAS_VIEW, NoiseSimilarMediasView);
#line 31 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->model);
#line 32 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->medias);
#line 34 "../plugins/LastFM/SimilarMediaView.vala"
	_g_object_unref0 (self->priv->urlsToOpen);
#line 30 "../plugins/LastFM/SimilarMediaView.vala"
	G_OBJECT_CLASS (noise_similar_medias_view_parent_class)->finalize (obj);
#line 639 "SimilarMediaView.c"
}

GType
noise_similar_medias_view_get_type (void)
{
	return noise_similar_medias_view_type_id;
}

GType
noise_similar_medias_view_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoiseSimilarMediasViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_similar_medias_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseSimilarMediasView), 0, (GInstanceInitFunc) noise_similar_medias_view_instance_init, NULL };
	noise_similar_medias_view_type_id = g_type_module_register_type (module, gtk_tree_view_get_type (), "NoiseSimilarMediasView", &g_define_type_info, 0);
	NoiseSimilarMediasView_private_offset = sizeof (NoiseSimilarMediasViewPrivate);
	return noise_similar_medias_view_type_id;
}

